#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7;

ll k;
vector<vector<ll> > masks;
vector<ll> b;

void foo(ll ind, ll mask, ll cnt, vector<ll> &gg) {
    if (ind == k * (k + 1) / 2) {
        if (cnt == 0) {
            gg.push_back(mask);
        }
        return;
    }
    if (k * (k + 1) / 2 - ind > cnt) {
        foo(ind + 1, mask * 2, cnt, gg);
    }
    if (cnt > 0) {
        foo(ind + 1, mask * 2 + 1, cnt - 1, gg);
    }
}

vector<map<ll, vector<ll> > > g;
vector<map<ll, ll> > dp;

ll calc(ll i, ll mask) {
    if (dp[i].contains(mask)) {
        return dp[i][mask];
    }
    if (i == 0) {
        return 0;
    }
    ll res = 0;
    for (auto &j: g[b[i - 1]][mask]) {
        res = (res + calc(i - 1, j)) % mod;
    }
    dp[i][mask] = res;
    return res;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n >> k;
    b.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> b[i];
    }
    masks.assign(k * k + 1, {});
    for (ll i = 0; i <= k * (k + 1) / 2; i++) {
        foo(0, 0, i, masks[i]);
    }
    dp.assign(n + 1, {});
    dp[0][0] = 1;
    g.assign(k * k + 1, {});
    for (ll i = 0; i <= k * k; i++) {
        for (ll mask: masks[i]) {
            ll mask1 = mask;
            for (ll z = 0; z < k; z++) {
                mask1 /= 2;
            }
            vector<ll> a;
            for (ll j = 0; j < k * (k + 1) / 2; j++) {
                a.push_back(mask % 2);
                mask /= 2;
            }
            reverse(a.begin(), a.end());
            ll gg = 0;
            for (ll j = 0; j < k; j++) {
                for (ll z = j * (j + 1) / 2; z < (j + 1) * (j + 2) / 2 - 1; z++) {
                    gg = gg * 2 + a[z];
                }
            }
            g[i][gg].push_back(mask1);
        }
    }
    ll ans = 0;
    for (auto &i: g[b[n - 1]]) {
        ans = (ans + calc(n, i.first)) % mod;
    }
    cout << ans;
}
