#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

constexpr ll mod = 1e9 + 7;

vector<vector<ll> > foo(vector<vector<ll> > &dp) {
    ll n = dp.size();
    vector<vector<ll> > res(n, vector<ll>(n, 0));
    res[0][0] = dp[0][0];
    for (int i = 1; i < n; i++) {
        res[0][i] = (res[0][i - 1] + dp[0][i]) % mod;
        res[i][0] = (res[i - 1][0] + dp[i][0]) % mod;
    }
    for (ll i = 1; i < n; i++) {
        for (ll j = 1; j < n; j++) {
            res[i][j] = (res[i - 1][j] + res[i][j - 1] - res[i - 1][j - 1] + dp[i][j]) % mod;
        }
    }
    return res;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll> > a(m);
    for (ll i = 0; i < k; i++) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        a[y].push_back(x);
    }
    for (ll i = 0; i < m; i++) {
        sort(a[i].begin(), a[i].end());
    }
    vector<vector<vector<ll> > > dp(m, vector<vector<ll> >(n, vector<ll>(n)));
    vector<vector<vector<ll> > > s(m, vector<vector<ll> >(n, vector<ll>(n)));
    for (ll i = 1; i < n; i++) {
        if (a[0].empty() || a[0].back() <= i) {
            dp[0][0][i] = 1;
        }
    }
    s[0] = foo(dp[0]);
    for (ll i = 1; i < m; i++) {
        for (ll y1 = 0; y1 < n; y1++) {
            for (ll y2 = y1 + 1; y2 < n; y2++) {
                if (a[i].empty() || a[i].back() <= y2) {
                    ll r1 = y1;
                    if (!a[i].empty() && a[i][0] < y1) {
                        r1 = a[i][0];
                    }
                    ll r2 = y2;
                    auto it = upper_bound(a[i].begin(), a[i].end(), y1);
                    if (it != a[i].end()) {
                        r2 = *it;
                    }
                    dp[i][y1][y2] = s[i - 1][r1][r2] - s[i - 1][r1][y1];
                }
            }
        }
        s[i] = foo(dp[i]);
    }
    cout << (2 * dp[m - 1][n - 2][n - 1]) % mod;
}
